import { RetentionPolicy } from '../template';
export declare function parseNumber(asString: string | number): {
    asString: string;
    asNumber: number;
};
export declare function assertString(x: unknown): string;
export declare function assertNumber(x: unknown): number;
export declare function assertList<T = unknown>(x: unknown, lengths?: number[]): T[];
export declare function assertListOfForm<T>(x: unknown, assertForm: (e: unknown) => T, form?: string): T[];
export declare function assertBoolean(x: unknown): boolean;
export declare function assertTrue(x: unknown): true;
export declare function assertObject(x: unknown): Record<string, unknown>;
export declare function assertField<A extends object, K extends keyof A>(xs: A, fieldName: K): unknown;
export declare function assertOneOf<A extends unknown>(x: A, allowed: unknown[]): A;
export declare function assertExactlyOneOfFields<A extends object, K extends keyof A>(xs: A, fieldNames: K[]): K;
export declare function assertAtMostOneOfFields<A extends object, K extends keyof A>(xs: A, fieldNames: K[]): K | undefined;
export declare function assertOneField(xs: unknown): string;
export declare function assertStringOrListIntoList(x: unknown): string[];
export declare function singletonList(x: string | undefined): string[];
export declare function parseRetentionPolicy(x: unknown): RetentionPolicy;
export declare function mapFromObject<A>(xs: unknown, fn: (x: unknown) => A): Map<string, A>;
export declare function assertOr<T>(x: unknown, error: (v: string) => string, ...assertions: Array<(e: unknown) => T>): T;
export declare function assertStringOrStringList(xs: unknown): string | string[];
