import { FactoryMethodCall } from './calls';
import { RetentionPolicy } from './enums';
import { TemplateExpression } from './expression';
import { ResourceOverride } from './overrides';
import { ResourceTag } from './tags';
import { schema } from '../schema';
export interface TemplateResource {
    readonly type?: string;
    readonly properties: Record<string, TemplateExpression>;
    readonly conditionName?: string;
    readonly dependencies: Set<string>;
    readonly dependsOn: Set<string>;
    readonly deletionPolicy: RetentionPolicy;
    readonly updateReplacePolicy: RetentionPolicy;
    readonly metadata: Record<string, unknown>;
    readonly tags: ResourceTag[];
    readonly overrides: ResourceOverride[];
    readonly call?: FactoryMethodCall;
    readonly creationPolicy?: TemplateExpression;
    readonly updatePolicy?: TemplateExpression;
}
export declare function parseTemplateResource(logicalId: string, resource: schema.Resource): TemplateResource;
