import * as reflect from 'jsii-reflect';
export declare class SchemaContext {
    static root(definitions?: {
        [fqn: string]: any;
    }, primitives?: {
        [type: string]: string;
    }): SchemaContext;
    readonly definitions: {
        [fqn: string]: any;
    };
    readonly primitives: {
        [type: string]: any;
    };
    readonly path: string;
    readonly children: SchemaContext[];
    readonly fqn: string;
    readonly name: string;
    readonly root: boolean;
    readonly warnings: string[];
    readonly errors: string[];
    private readonly definitionStack;
    private constructor();
    child(type: string, fqn: string, shortName?: string): SchemaContext;
    hasWarningsOrErrors(ignore?: string[]): boolean;
    warning(format: any, ...args: any[]): void;
    error(format: any, ...args: any[]): void;
    findDefinition(ref: string): any;
    define(fqn: string, schema: (ctx: SchemaContext) => any): {
        $ref: string;
    } | undefined;
    isDefined(fqn: string): boolean;
}
export declare function schemaForTypeReference(type: reflect.TypeReference, ctx: SchemaContext): any;
export declare function schemaForEnumLikeClass(type: reflect.Type | undefined, ctx: SchemaContext): {
    $ref: string;
} | undefined;
