import * as reflect from 'jsii-reflect';
interface PropertySpec {
    Remarks: string;
    Summary: string;
    Required: boolean;
    Type: string;
    ItemType?: string;
    Static?: boolean;
}
interface ParameterSpec {
    readonly Summary: string;
    readonly Type: string;
}
interface MethodSpec {
    readonly Summary: string;
    readonly Remarks: string;
    readonly Static: boolean;
    readonly Parameters: Record<string, ParameterSpec>;
    readonly ReturnType?: string;
}
interface ResourceTypeSpec {
    readonly Properties: Record<string, PropertySpec>;
    readonly Methods: Record<string, MethodSpec>;
    readonly PublicProperties: Record<string, PropertySpec>;
}
interface ModuleTypeSpec {
    readonly ResourceTypes: Record<string, ResourceTypeSpec>;
    readonly PropertyTypes: Record<string, ResourceTypeSpec>;
    readonly InterfaceTypes: Record<string, ResourceTypeSpec>;
}
interface RootSpec {
    readonly schemaVersion: string;
    readonly ModuleTypes: Record<string, ModuleTypeSpec>;
}
export declare function generateDeCDKSpecs(typeSystem: reflect.TypeSystem): RootSpec;
export {};
