import * as reflect from 'jsii-reflect';
import { TypedArrayExpression } from './expression';
import { ResolveReferenceExpression } from './references';
import { TypeResolutionContext } from './resolve';
import { ArrayLiteral, ObjectLiteral } from '../parser/template';
import { FactoryMethodCall } from '../parser/template/calls';
export interface StaticMethodCallExpression {
    readonly type: 'staticMethodCall';
    readonly fqn: string;
    readonly namespace?: string;
    readonly method: string;
    readonly args: TypedArrayExpression;
}
export interface InstanceMethodCallExpression {
    readonly type: 'instanceMethodCall';
    readonly target: ResolveReferenceExpression;
    readonly method: string;
    readonly args: TypedArrayExpression;
}
export declare function methodFQN(method: reflect.Method): string;
export declare function resolveStaticMethodCallExpression(call: FactoryMethodCall, typeSystem: reflect.TypeSystem, resultType?: reflect.Type): StaticMethodCallExpression;
export declare function resolveInstanceMethodCallExpression(call: Required<FactoryMethodCall>, ctx: TypeResolutionContext, resultType?: reflect.Type): InstanceMethodCallExpression;
export interface InitializerExpression {
    readonly type: 'initializer';
    readonly fqn: string;
    readonly namespace?: string;
    readonly args: TypedArrayExpression;
}
export declare function resolveInstanceExpression(x: ObjectLiteral, type: reflect.InterfaceType | reflect.ClassType): InitializerExpression | StaticMethodCallExpression;
export declare function assertInitializer(type: reflect.Type): reflect.Initializer;
export declare function resolveArguments(x: ArrayLiteral, callable: reflect.Callable): TypedArrayExpression;
