import * as reflect from 'jsii-reflect';
import { TypedTemplateExpression, TypedTemplateOutput } from './expression';
import { ResourceLike } from './resource-like';
import { AnnotationsContext } from '../error-handling';
import { DependencyGraph } from '../parser/private/toposort';
import { Template, TemplateParameter } from '../parser/template';
import { TemplateHook } from '../parser/template/hooks';
import { TemplateMapping } from '../parser/template/mappings';
import { TemplateRule } from '../parser/template/rules';
export interface TypedTemplateProps {
    typeSystem: reflect.TypeSystem;
    annotations?: AnnotationsContext;
}
/**
 * A template describes the desired state of some infrastructure
 */
export declare class TypedTemplate {
    template: Template;
    readonly description?: string;
    readonly templateFormatVersion?: string;
    readonly resources: DependencyGraph<ResourceLike>;
    readonly parameters: Map<string, TemplateParameter>;
    readonly conditions: Map<string, TypedTemplateExpression>;
    readonly mappings: Map<string, TemplateMapping>;
    readonly outputs: Map<string, TypedTemplateOutput>;
    readonly transform: string[];
    readonly metadata: Map<string, unknown>;
    readonly rules: Map<string, TemplateRule>;
    readonly hooks: Map<string, TemplateHook>;
    constructor(template: Template, props: TypedTemplateProps);
    resource(logicalId: string): ResourceLike;
}
